// DetailsThread.h: interface for the CDetailsThread class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DETAILSTHREAD_H__A345E6A1_04FA_11D5_A176_080046068885__INCLUDED_)
#define AFX_DETAILSTHREAD_H__A345E6A1_04FA_11D5_A176_080046068885__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "encspot.h"


class CDetailsThread
{
	tstring m_path;

public:

	void Abort()
	{
		SetEvent(m_hAbort);
	}

	HANDLE m_hMutex;		//used to handle access rights
	HANDLE m_hEvent;		//used to signal when done.
	HANDLE m_hAbort;
	HWND   m_hWndPar;
	CDetailsThread(tstring path);
	virtual ~CDetailsThread();

	static void StaticThreadProc(void *This) 
	{ 
		((CDetailsThread *)This)->Main(); 
	}

	void Main();

	void WaitForClose(int dir = -1)
	{	
		WaitForSingleObject(m_hEvent,INFINITE);
	}


	void Begin() { _beginthread(StaticThreadProc,0,this); }


};

#endif // !defined(AFX_DETAILSTHREAD_H__A345E6A1_04FA_11D5_A176_080046068885__INCLUDED_)
