#pragma once

template <class X>
class singleton   
{
	typedef singleton<X>	thisClass;

	static bool m_destroyed;
	static thisClass *m_pInstance;

	static void CreateSingleton()
	{
		static thisClass obj;
		m_pInstance = &obj;
	}


	X m_data;

	
protected:

	singleton() {}

public:
	virtual ~singleton()
	{
		m_pInstance = NULL;
		m_destroyed = true;
	}

	static X &Instance()
	{
		if (!m_pInstance)
		{
			if (m_destroyed)
				throw "Dead reference!!";
			else
				CreateSingleton();
		}

		return m_pInstance->m_data;
	}
};



template<class X>
bool singleton<X>::m_destroyed = false;

template<class X>
singleton<X> *singleton<X>::m_pInstance = NULL;

