// ListThread.h: interface for the CListThread class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LISTTHREAD_H__107619A0_0660_11D5_A176_080046068885__INCLUDED_)
#define AFX_LISTTHREAD_H__107619A0_0660_11D5_A176_080046068885__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EncSpotShellSupport\pidl.h"
#include "encspot.h"
#include "itemdata.h"
#include "EncSpotLib/Thread.h"


//sent to CEncSpotList
#define WM_THREADDONE	WM_USER+6
#define WM_BADFILE		WM_USER+40

//to us
#define WM_PROCESSMULTI		WM_USER + 2
//#define WM_PROCESSSINGLE	WM_USER + 3


class CListThread  : public CThread<CListThread>
{ 
	typedef CThread<CListThread> base;
public:
	void StopEverythingNow();


	BEGIN_THREAD_MAP()
		THREAD_HANDLER(WM_PROCESSMULTI,		OnProcessMulti)	
	//	THREAD_HANDLER(WM_PROCESSSINGLE,	OnProcessSingle)	
	END_THREAD_MAP()


	HWND m_hWndMain;
	
	CListThread(BOOL run, int *pFres, BOOL *pMono, BOOL *pReadAll) : m_pReadAllUnknown(pReadAll), m_pMonoQuality(pMono), m_pFrameResolution(pFres), base(run) {}

	virtual ~CListThread() {}

private:

	//settings
	int *m_pFrameResolution;
	BOOL*m_pMonoQuality;
	BOOL*m_pReadAllUnknown;


	BOOL	OnProcess(WPARAM wParam, LPARAM lParam);
	BOOL	OnProcessMulti(WPARAM wParam, LPARAM lParam);
	BOOL	DoProcess(string path, mp3data &data, mp3data_string &data_string, LPLVITEMDATA lplvid, int cap);
	BOOL	OnProcessSingle(WPARAM wParam, LPARAM lParam);

};

#endif // !defined(AFX_LISTTHREAD_H__107619A0_0660_11D5_A176_080046068885__INCLUDED_)
