#pragma once



class CPropTree :	public CPropertyPageImpl<CPropTree>,
					public CWinDataExchange<CPropTree> 
{
public:

	BOOL *m_pDirty;

	
	TCHAR m_initdir[MAX_PATH];
	BOOL m_userecent;

	enum { IDD = IDD_PROPTREE };

	BEGIN_MSG_MAP(CPropTree)
		COMMAND_ID_HANDLER(IDC_CHECKRECENT, OnRecent)		
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)		
		CHAIN_MSG_MAP(CPropertyPageImpl<CPropTree>)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CPropTree)
		DDX_TEXT(IDC_EDITINIT,		m_initdir)
		DDX_CHECK(IDC_CHECKRECENT,	m_userecent)
	END_DDX_MAP()

	BOOL OnApply()
	{
		DoDataExchange(TRUE);
		return TRUE;
	}

	LRESULT OnRecent(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		BOOL is = (IsDlgButtonChecked(IDC_CHECKRECENT) == BST_CHECKED);
		::EnableWindow(GetDlgItem(IDC_EDITINIT),!is);
	
		return 0;
	}
	
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		DoDataExchange(FALSE);
		::EnableWindow(GetDlgItem(IDC_EDITINIT),!m_userecent);


		bHandled = FALSE;
		return 0;
	}	
};



