#include "stdafx.h"
#include "resource.h"
#include <atlwin.h>
#include <atlctrls.h>
#include <atlctrlx.h>
#include <atldlgs.h>
#include <atlmisc.h>


#include "EncSpot.h"
#include "aboutdlg.h"
#include "EncSpot_build.h"


CAboutDlg::CAboutDlg()
{
	m_pweblink = new CHyperLink;
	m_pmaillink= new CHyperLink;

}
CAboutDlg::~CAboutDlg()
{
	delete m_pweblink;
	delete m_pmaillink;
	
}

LRESULT CAboutDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	CRect r;
	::GetWindowRect(GetDlgItem(IDC_STATICCONTACT), &r);
	ScreenToClient(&r);

	r.top += 20;
	r.bottom = r.top + 15;
	r.left   += 40;
	m_pmaillink->Create(m_hWnd,r);
	m_pmaillink->SetHyperLink(_T("mailto:dee@guerillasoft.com"));
	m_pmaillink->SetLabel(_T("dee@guerillasoft.com"));
	m_pmaillink->ShowWindow(SW_SHOW);

	r.OffsetRect(0,25);
	m_pweblink->Create(m_hWnd,r);
	m_pweblink->SetHyperLink(_T("http://www.guerillasoft.com/encspot"));
	m_pweblink->SetLabel(_T("www.guerillasoft.com/encspot"));
	m_pweblink->ShowWindow(SW_SHOW);




	CenterWindow(GetParent());

	TCHAR b[10];
	tstring verplus = g_version;
	verplus += _T(" beta 1, build ") + tstring(_itot(BUILDNUM_ENCSPOTWIN32RELEASE,b,10));
	SetDlgItemText(IDC_STATICVERSION, verplus.c_str());

	return TRUE;
}